extends ../includes/layout
block content
    style. 
        .btn-w{
            width:150px;
        }

        .pictures{
            width: 100%;
            height: auto;
            border
        }

        #order_name{
            font-size: 33px;
        }
        #btn_bid{
            font-size: 25px;
            width:100%;
        }
        #picsss{
            font-size: 25px;
            width:100%;
            margin-top: 20px;
        }

        .message_bid{
            padding:2px;



        }

        .badge{
            font-size: 14px;
        }

        #bids{
            width:100%;
            height: 217px;
        }


    .container(style="padding-top:0px;margin-top:0px;")
        .row
            .col-xl-12
                .row.page-titles.my-3
                    ol.breadcrumb
                        li.breadcrumb-item.active
                            a(href=base_url+'home') Auction
                        li.breadcrumb-item
                            a(href='javascript:void(0)')=lot.name
        .row
            .col-lg-12
                .card
                    .card-body(style="padding-top:0px;margin-top:0px;")

                        .row
                            .col-xl-8.col-lg-6.col-md-6.col-xxl-7.col-sm-12(style="padding:15px;")
                                h1.m-b-15#order_name -
                                h3.m-b-15#product_detail(style="padding-top:20px;") -
                                h3.m-b-15#product_price_start -
                                h3.m-b-15#product_step -


                                //textarea#bids(rows='10' style="width:100%")
                                #bids(style="border: 1px solid #aba4a4 !important;").border


                                input(type="hidden" name="lot_id" id="lot_id", value=lotId)  
                                input(type="hidden" name="product_id" id="product_id", value=`${product._id}`)  

                            .col-xl-4.col-lg-6.col-md-6.col-xxl-5.col-sm-12(style="padding:15px;")
                                button.btn.btn-primary.btn-w#btn_bid(data-room=lot._id)
                                    #h4display=product.startPrice
                                #picsss 
                                    .text-center#pictures






block script
    script(src='/socket.io/socket.io.js')
    script.
        const socket = io();
        const lot_id = $('#lot_id').val()

        let product_id = $('#product_id').val()
        let product_price_finish = 0
        let product_step = 0
        let i = 0
        let x = 0
        let ref

        $('#btn_bid').click(function(){

            if(product_price_finish==0){
                product_price_finish = product_price_finish+product_step
            }else{
                product_price_finish = product_price_finish+product_step
            }

            console.log(product_price_finish)

            bid_product()

        })


        function bid_product(){

            let product_win = $('#product_win').val()
            let status = 'bid'

            socket.emit('setBid', lot_id,{product_id,product_price_finish,product_win,user_id,status,auction_board},function (res) {
                console.log(res)
            });


        }


        if(product_id!=''){
            load_product()
        }

        console.log('product_id : ',product_id)

        socket.emit("join", lot_id);

        socket.on('setBid', function(result) {
            console.log('------------------------------')
            console.log('socket : ',result.datas)
            console.log('product_win : ',result.datas.product_win)
            console.log('product_id : ',product_id)

            if(product_id!='' && product_id!=null){
                console.log('bid 0')
                if(result.datas.product_win==null || result.datas.product_win==''){
                    $('#user_win').text('-')
                    console.log('bid 1')
                }else{
                    $('#user_win').text(result.datas.product_win)
                    console.log('bid 2')
                }


                if(result.datas.product_id==product_id){

                    if(result.datas.product_price_finish==0 || result.datas.product_price_finish=='0'){
                        $('#h4display').text('-')
                    }else if(result.datas.product_price_finish!=null && result.datas.product_price_finish!=''){
                        product_price_finish = result.datas.product_price_finish

                        $('#h4display').text(numberWithCommas(result.datas.product_price_finish))
                    }

                    if(result.datas.status=='bid'){
                        if(result.datas.auction_board==auction_board){
                            $("#bids").append('<div class="message_bid"><span class="badge bg-secondary">'+result.datas.auction_board+' : '+numberWithCommas(result.datas.product_price_finish)+'</span></div>');
                        }else{
                            $("#bids").append('<div class="message_bid"><span class="badge bg-dark">'+result.datas.auction_board+' : '+numberWithCommas(result.datas.product_price_finish)+'</span></div>');
                        }
                    }else  if(result.datas.status=='sold'){
                        $("#bids").append('<div class="message_bid"><span class="badge bg-warning">จบการประมูลที่ราคา : '+numberWithCommas(result.datas.product_price_finish)+'</span></div>');
                    }


                    console.log('message_bid : ',$('.message_bid').length)

                    if($('.message_bid').length>6){
                        $('.message_bid').first().remove();
                    }



                    if(result.datas.status=='sold'){
                        sweetAlert("จบการประมูล","ผู้ชนะ : "+result.datas.product_win+" ราคา : "+result.datas.product_price_finish, "success")
                    }



                }else{

                    product_id = result.datas.product_id
                    load_product()

                }

            }

        });

        setInterval(function() {

            socket.emit("join", lot_id);
        }, 30000);


        function load_product(){
            $.ajax({
                url: "#{base_url}admin/auction/load_product",
                headers: {
                    'Authorization': 'Bearer '+access_token,
                },
                method: "POST",
                dataType: "json",
                data:{
                    product_id:product_id
                },
                success: function (res, status, xhr) {
                    if(status=='success' && xhr.status==200 && res.result){

                        product_id = res.product._id


                        product_price_finish = res.product.startPrice 

                        if(res.product.cur_Price> res.product.startPrice ){
                            product_price_finish = res.product.cur_Price
                        }
                        product_step = res.product.step

                        $("#pictures").empty()
                        i = res.product.pictures.length


                        $('#order_name').text('ลำดับที่ '+res.product.orderNo +' : '+res.product.name)
                        $('#product_price_start').text('ราคาเปิด : '+numberWithCommas(res.product.startPrice))
                        $('#product_detail').text('รายละเอียด : '+res.product.detail)
                        $('#product_step').text('บิดครั้งละ : '+numberWithCommas(res.product.step))

                        $("#bids").append('<div class="message_bid"><span class="badge bg-warning">เริ่มต้นประมูลลำดับที่ '+res.product.orderNo +' : '+res.product.name);

                        $('#h4display').text(numberWithCommas(product_price_finish))

                        if(i==0){
                            $('<img src="/images/logo-auction.png" class="pictures border" id="picture-0">').appendTo("#pictures");
                        }else{
                            $(res.product.pictures).each(function(key,val){
                                console.log(key)
                                console.log(val)

                                if(key==0){
                                    $('<img src="/uploads/'+val+'" class="pictures border" id="picture-'+key+'">').appendTo("#pictures");
                                }else{
                                    $('<img src="/uploads/'+val+'" class="pictures border hide" id="picture-'+key+'">').appendTo("#pictures");
                                }
                            })
                        }


                    }else{
                        sweetAlert("Oops...", data.message, "error");
                    }
                },
                error: function (xhr, status, error) {
                    alert_error(xhr,error)
                },
            });
        }

        function numberWithCommas(x) {
            return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
        }

        clearInterval(ref);

        ref = setInterval(function() {
            $('.pictures').hide();

            $('#picture-' + x).show();

            if (x < i - 1) {
                x = x + 1;

            } else {
                x = 0;
            }

        }, 3000);        